--- /dev/null
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2026 Oracle. All Rights Reserved.
+#
+# FS QA Test No. 667
+#
+# Ensure that autonomous self healing fixes the filesystem correctly even if
+# the original mount has moved somewhere else via --move.
+#
+. ./common/preamble
+_begin_fstest auto selfhealing mount
+
+. ./common/filter
+. ./common/fuzzy
+. ./common/systemd
+
+if [ -n "$IN_MOUNTNS" ]; then
+ _mount --make-rprivate /
+ findmnt -o TARGET,PROPAGATION >> $seqres.full
+
+ _scratch_mount
+ _scratch_invoke_xfs_healer "$tmp.healer" --repair
+
+ # Move the scratch filesystem to a completely different mountpoint so that
+ # we can test if the healer can find it again.
+ new_dir=$TEST_DIR/moocow
+ mkdir -p $new_dir
+ _mount --move $SCRATCH_MNT $new_dir
+
+ df -t xfs >> $seqres.full
+
+ # Access the broken directory to trigger a repair, then poll the directory
+ # for 5 seconds to see if it gets fixed without us needing to intervene.
+ ls $new_dir/some/victimdir > /dev/null 2> $tmp.err
+ _filter_scratch < $tmp.err | _filter_test_dir
+ try=0
+ while [ $try -lt 50 ] && grep -q 'Structure needs cleaning' $tmp.err; do
+ echo "try $try saw corruption" >> $seqres.full
+ sleep 0.1
+ ls $new_dir/some/victimdir > /dev/null 2> $tmp.err
+ try=$((try + 1))
+ done
+ echo "try $try no longer saw corruption or gave up" >> $seqres.full
+ _filter_scratch < $tmp.err | _filter_test_dir
+
+ # List the dirents of /victimdir to see if it stops reporting corruption
+ ls $new_dir/some/victimdir > /dev/null 2> $tmp.err
+ try=0
+ while [ $try -lt 50 ] && grep -q 'Structure needs cleaning' $tmp.err; do
+ echo "retry $try still saw corruption" >> $seqres.full
+ sleep 0.1
+ ls $SCRATCH_MNT/some/victimdir > /dev/null 2> $tmp.err
+ try=$((try + 1))
+ done
+ echo "retry $try no longer saw corruption or gave up" >> $seqres.full
+
+ new_dir_unmount() {
+ _unmount $new_dir
+ }
+
+ # Unmount to kill the healer
+ _scratch_kill_xfs_healer new_dir_unmount
+ cat $tmp.healer >> $seqres.full
+
+ # No need to clean up, the mount ns destructor will detach the
+ # filesystems for us.
+ exit
+fi
+
+_cleanup()
+{
+ command -v _kill_fsstress &>/dev/null && _kill_fsstress
+ cd /
+ rm -r -f $tmp.*
+ if [ -n "$new_dir" ]; then
+ _unmount "$new_dir" &>/dev/null
+ rm -rf "$new_dir"
+ fi
+}
+
+_require_unshare
+_require_test
+_require_scrub
+_require_xfs_io_command "repair" # online repair support
+_require_xfs_db_command "blocktrash"
+_require_command "$XFS_HEALER_PROG" "xfs_healer"
+_require_command "$XFS_PROPERTY_PROG" "xfs_property"
+_require_scratch
+
+_scratch_mkfs >> $seqres.full
+_scratch_mount
+
+_xfs_has_feature $SCRATCH_MNT rmapbt || \
+ _notrun "reverse mapping required to test directory auto-repair"
+_xfs_has_feature $SCRATCH_MNT parent || \
+ _notrun "parent pointers required to test directory auto-repair"
+_require_xfs_healer $SCRATCH_MNT --repair
+
+# Configure the filesystem for automatic repair of the filesystem.
+$XFS_PROPERTY_PROG $SCRATCH_MNT set autofsck=repair >> $seqres.full
+
+# Create a largeish directory
+dblksz=$(_xfs_get_dir_blocksize "$SCRATCH_MNT")
+echo testdata > $SCRATCH_MNT/a
+mkdir -p "$SCRATCH_MNT/some/victimdir"
+for ((i = 0; i < (dblksz / 255); i++)); do
+ fname="$(printf "%0255d" "$i")"
+ ln $SCRATCH_MNT/a $SCRATCH_MNT/some/victimdir/$fname
+done
+
+# Did we get at least two dir blocks?
+dirsize=$(stat -c '%s' $SCRATCH_MNT/some/victimdir)
+test "$dirsize" -gt "$dblksz" || echo "failed to create two-block directory"
+
+# Break the directory, remount filesystem
+_scratch_unmount
+_scratch_xfs_db -x \
+ -c 'path /some/victimdir' \
+ -c 'bmap' \
+ -c 'dblock 1' \
+ -c 'blocktrash -z -0 -o 0 -x 2048 -y 2048 -n 2048' >> $seqres.full
+
+# mount --move only works if mount propagation is disabled, so we have to start
+# a subshell with a separate mount namespace, disable propagation for the
+# entire directory tree, and only then can we run our tests.
+IN_MOUNTNS=1 unshare -m bash "$0"
+
+_exit 0